def is_solution(board):
    # returns True or False, indicating
    # if the input is a 9 knights solution

    moves = [(-2, -1), (-2, 1), (-1, -2), (-1, 2),
             (1, -2), (1, 2), (2, -1), (2, 1)]

    num_k = 0

    # for each board position
    for row in range(5):
        for col in range(5):
            # if it has a knight
            if board[row][col] == "k":
                num_k += 1
                # try every knight move to see if it attacks another knight
                for move in moves:
                    # get where the move would land
                    n_row, n_col = row+move[0], col+move[1]
                    # make sure it lands in the board before we check
                    if 0 <= min(n_row, n_col) and max(n_row, n_col) <= 4:
                        # if there is a knight there, then this is not a
                        # valid solution
                        if board[n_row][n_col] == "k":
                            return False

    return num_k == 9

board = [input() for x in range(5)]

# now board[r][c] is the character on row
# r, column c (indexing 0 through 4)

print("valid" if is_solution(board) else "invalid")
