#include <iostream>
#include <cmath>
#include <string>

#define EPS 1e-8

using namespace std;

struct Splat {
    double x, y, rad;
    string colour;
};


int main() {
    int canvases;
    cin >> canvases;
    Splat splats[200];

    for (int c = 0; c < canvases; ++c) {
        // now solve the problem for a single canvas

        int n_splats;
        cin >> n_splats;

        for (int i = 0; i < n_splats; ++i) {
            double v;
            cin >> splats[i].x >> splats[i].y >> v
                >> splats[i].colour;
            splats[i].rad = sqrt(v/acos(-1.0));
        }

        int n_queries;
        cin >> n_queries;

        for (int i = 0; i < n_queries; ++i) {
            double x, y;
            cin >> x >> y;

            string answer = "white";
            for (int j = n_splats-1; j >= 0; --j) {
                double dx = x-splats[j].x, dy = y-splats[j].y;
                if (dx*dx + dy*dy <= splats[j].rad*splats[j].rad + EPS) {
                    answer = splats[j].colour;
                    break;
                }
            }
            cout << answer << endl;
        }
    }

    return 0;
}
